//+------------------------------------------------------------------+
//|                                        Classic ZigZag Expert.mq4 |
//|                                        Copyright  2008, Rone_IS |
//|                                            rone.sergey@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Powered by Rone_IS."
#property link      "rone.sergey@gmail.com"

extern int MAGIC=20080609;
extern double ReversePercent=0.2;
extern bool UseReverseInPoints = false;
extern int ReversePoints = 30;
bool ShowNoChangeTrack = false;
extern int  ShiftBars    = 2;
extern int StopIndent=5;
extern double Lot=0.1;
//----------------------
int start()
  {
  //  
  double y3=0, y2=0, y1=0, y0, zz;    //  -
  int    x3, x2, x1, sh=ShiftBars;//  
  double stop;
  
  y0=iCustom(NULL,0,"Classic ZigZag",ReversePercent,UseReverseInPoints,ReversePoints,ShowNoChangeTrack,0,1);
  //    -
   while (y3==0) 
      {
      zz=iCustom(NULL,0,"Classic ZigZag",ReversePercent,UseReverseInPoints,ReversePoints,ShowNoChangeTrack,0,sh);
      if (zz!=0 && zz!=EMPTY_VALUE) 
         {
         if      (y1==0) { x1=sh; y1=zz; }
         else if (y2==0) { x2=sh; y2=zz; }
         else if (y3==0) { x3=sh; y3=zz; }
         }
      sh++;
      }  
//----
   if(!ExistPositions())
      {
      if(y0 != EMPTY_VALUE && y0>y1 && y1<y2 && y0>y2 && High[1]>=y0 && Close[2]<y0) 
         {
         stop = y1-StopIndent*Point;
         OrderSend(Symbol(), OP_BUY, Lot, Ask, 0, stop, 0, "", MAGIC, 0, Blue);
         return(0);
         }
      if(y0 != EMPTY_VALUE && y0<y1 && y1>y2 && y0<y2 && Low[1]<=y0 && Close[2]>y0)
         {
         stop = y1+StopIndent*Point;
         OrderSend(Symbol(), OP_SELL, Lot, Bid, 0, stop, 0, "", MAGIC, 0, Red);
         return(0);
         }
      }
   if(ExistPositions())
      {
      if(OrderType() == OP_BUY)
         {
         if(y0 != EMPTY_VALUE && y0<y1 && y1>y2 && Low[1]<=y0 && Close[2]>y0)
            {
            OrderClose(OrderTicket(), OrderLots(), Bid, 0, Orange);
            if (y0 != EMPTY_VALUE && y0<y1 && y1>y2 && y0<y2 && Low[1]<=y0 && Close[2]>y0)
               {
               stop = y1+StopIndent*Point;
               OrderSend(Symbol(), OP_SELL, Lot, Bid, 0, stop, 0, "", MAGIC, 0, Red);
               return(0);
               }
            }
         }
      if(OrderType() == OP_SELL)
         {
         if(y0 != EMPTY_VALUE && y0>y1 && y1<y2 && High[1]>=y0 && Close[2]<y0)
            {
            OrderClose(OrderTicket(), OrderLots(), Ask, 0, Orange);
            if (y0 != EMPTY_VALUE && y0>y1 && y1<y2 && y0>y2 && High[1]>=y0 && Close[2]<y0)
               {
               stop = y1-StopIndent*Point;
               OrderSend(Symbol(), OP_BUY, Lot, Ask, 0, stop, 0, "", MAGIC, 0, Blue);
               return(0);
               }
            }
         }
      }   
   return(0);
  }
//+------------------------------------------------------------------+
bool ExistPositions()
   {
   for(int i=0;i<OrdersTotal();i++)
      {
      if(OrderSelect(i, SELECT_BY_POS,MODE_TRADES))
         {
         if(OrderSymbol() == Symbol() && OrderMagicNumber() == MAGIC)
            {
            return(True);
            }
         }
      }
   return(false);
   } 

